package org.netkernel.mod.performance.async;

import java.util.concurrent.atomic.AtomicInteger;

import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.layer0.nkf.INKFAsyncRequestListener;
import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.nkf.NKFException;

public class AsyncTestAccessorBusy extends StandardAccessorImpl implements INKFAsyncRequestListener
{
	private AtomicInteger mInt = new AtomicInteger(0);
	private static final int N=20;
	
	public AsyncTestAccessorBusy()
	{	//declareThreadSafe(); // cannot be thread safe because of shared member state in mInt!!
	}	
	
	public void onSource(INKFRequestContext aHelper) throws Exception
	{	
		//System.err.println("AsyncTestAccessor starting");
		mInt.set(0);
		for (int i=0; i<N; i++)
		{	INKFRequest req = aHelper.createRequest("active:async-busy3");
			req.addArgument("op", "data:,"+Integer.toString(i));
			aHelper.issueAsyncRequest(req).setListener(this);
		}
		aHelper.setNoResponse();
	}

	public void receiveException(NKFException aException, INKFRequest aRequest, INKFRequestContext aContext) throws Exception
	{	throw aException;
	}

	public void receiveResponse(INKFResponseReadOnly aResponse, INKFRequestContext aContext) throws Exception
	{	
		int v=mInt.incrementAndGet();
		if (v==N)
		{	aContext.createResponseFrom(aResponse.getRepresentation().toString());
			//System.err.println("send a response from AsyncTestAccessor "+System.identityHashCode(aContext)+" "+System.identityHashCode(aContext.getThisRequest()));
		}
		else
		{	aContext.setNoResponse();
		}
	}
}
