package org.netkernel.mod.performance.cache;

import java.util.Random;

import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFRequestReadOnly;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;

public class CachableComputeLightNormalDataSet extends StandardAccessorImpl
{
	private Random mRandom = new Random(0);
	
	public CachableComputeLightNormalDataSet()
	{	declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext aHelper) throws Exception
	{
		INKFRequestReadOnly thisReq=aHelper.getThisRequest();
		String kbString=thisReq.getArgumentValue("Kb");
		String setSize=thisReq.getArgumentValue("setSize");
		Double N=Double.parseDouble(setSize)/4.0;
		
		double g=mRandom.nextGaussian();
		int item=(int)(g*N);
		
		//int item=(int)(Math.random()*M);
		Class repClass=thisReq.getRepresentationClass();
		INKFResponseReadOnly res=aHelper.sourceForResponse("res:/cache/CachableComputeLightItem/"+kbString+"/"+Integer.toString(item),repClass);
		INKFResponse resp=aHelper.createResponseFrom(res.toString());
		resp.setExpiry(INKFResponse.EXPIRY_ALWAYS);
	}
}
