<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml"/>
	
    <xsl:template match="/*">
		<div>
		
		<canvas id="cache" width="400" height="300">This text is displayed if your browser does not support HTML5 Canvas.
  		</canvas>
  
  <script type="text/javascript">
    var g = new Bluff.Line('cache', '400x300');
    g.title = 'Caching Performance';
    g.x_axis_label="Dataset Size";
    g.tooltips = true;
    g.y_axis_increment=25;
    g.minimum_value=0;
    g.maximum_value=100;

    g.theme_37signals();
    
    g.labels = {
    	<xsl:for-each select="CachableComputeLightDataSet/test">
			<xsl:value-of select="position()-1"/>:   '<xsl:value-of select="position()"/>',
    	</xsl:for-each>
    };
    
    
    <xsl:variable name="max-throughput">
     <xsl:for-each select="CachableComputeLightDataSet/test/throughput">
       <xsl:sort data-type="number" order="descending"/>
       <xsl:if test="position()=1"><xsl:value-of select="."/></xsl:if>
     </xsl:for-each>
   </xsl:variable>
    
    
    g.data("Uniform", [
    	<xsl:for-each select="CachableComputeLightDataSet/test">
    		<xsl:value-of select="100*throughput div $max-throughput"/>
    		<xsl:if test="last()">
    			<xsl:text>, </xsl:text>
    		</xsl:if>
    	</xsl:for-each>
    ]);
    
    g.data("Normal", [
    	<xsl:for-each select="CachableComputeLightNormalDataSet/test">
    		<xsl:value-of select="100*throughput div $max-throughput"/>
    		<xsl:if test="last()">
    			<xsl:text>, </xsl:text>
    		</xsl:if>
    	</xsl:for-each>
    ]);
    
    g.draw();
  </script>
		
		</div>
	</xsl:template>


</xsl:stylesheet>