<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml"/>
	
    <xsl:template match="/mark">
		<div>
			<table>
				<tr>
					<td>
						<canvas id="mark" width="400" height="200">This text is displayed if your browser does not support HTML5 Canvas.
			  			</canvas>
					</td>
					<td>
						<table>
							<tr><td class="label" style="vertical-align: middle">NKMark10:</td><td colspan="2"><span style="font-size: 400%; font-weight: bold;"><xsl:value-of select="mark"/></span></td></tr>
							<tr><td class="label">Hostname:</td><td><xsl:value-of select="hostname"/></td></tr>
							<tr><td class="label">Timestamp:</td><td><xsl:value-of select="time"/></td></tr>
							<tr><td colspan="2"><hr/></td></tr>
							<tr><td class="label">Synchronous:</td><td><xsl:value-of select="sync-mark"/></td></tr>
							<tr><td class="label">Asynchronous:</td><td><xsl:value-of select="async-mark"/></td></tr>
							<tr><td class="label">Garbage Collection:</td><td><xsl:value-of select="gc-mark"/></td></tr>
							<tr><td class="label">IO Read:</td><td><xsl:value-of select="io-read-mark"/></td></tr>
							<tr><td class="label">IO Write:</td><td><xsl:value-of select="io-write-mark"/></td></tr>
						</table>
					</td>
				</tr>
				<tr>
					<td>
						<canvas id="cpu" width="400" height="200">This text is displayed if your browser does not support HTML5 Canvas.
			  			</canvas>
					</td>
				</tr>
			</table>
		
  			
  			<script type="text/javascript">
			    var g = new Bluff.SideBar('mark', '400x200');
			    g.title = 'NKMark10';
			    //g.tooltips = true;
			    g.sort=false;
			    g.bar_spacing=1.0;
			    //g.y_axis_increment=50;
			    //g.marker_count=5;
			    g.minimum_value=0;
			    g.theme_37signals();
			    g.data("Synchronous", [ <xsl:value-of select="sync-mark"/> ]);
			    g.data("Asynchronous", [ <xsl:value-of select="async-mark"/>,0 ]);
			    g.data("GC", [ <xsl:value-of select="gc-mark"/> ]);
			    g.data("IO Read", [ <xsl:value-of select="io-read-mark"/> ]);
			    g.data("IO Write", [ <xsl:value-of select="io-write-mark"/> ]);
    			g.draw();
    			
			    var g = new Bluff.SideBar('cpu', '400x200');
			    g.title = 'CPU Utilisation';
			    g.theme_37signals();
			    g.sort=false;
			    //g.y_axis_increment=25;
			    g.minimum_value=0;
			    g.maximum_value=100;
			    g.data("Synchronous", [ <xsl:value-of select="sync-cpu"/> ]);
			    g.data("Asynchronous", [ <xsl:value-of select="async-cpu"/>,0 ]);
			    g.data("GC", [ <xsl:value-of select="gc-cpu"/> ]);
			    g.data("IO Read", [ <xsl:value-of select="io-read-cpu"/> ]);
			    g.data("IO Write", [ <xsl:value-of select="io-write-cpu"/> ]);
    			g.draw();
    			
    			
  </script>
  		
		</div>
	</xsl:template>


</xsl:stylesheet>