<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml"/>
	
    <xsl:template match="/*">
		<div>
		
		<canvas id="sync" width="400" height="300">This text is displayed if your browser does not support HTML5 Canvas.
  		</canvas>
  
  <script type="text/javascript">
    var g = new Bluff.Line('sync', '400x300');
    g.title = 'Scaling Concurrent Requests';
    g.x_axis_label="Concurrent Requests";
    g.tooltips = true;
    g.y_axis_increment=25;
    g.minimum_value=0;
    g.maximum_value=100;

    g.theme_37signals();
    
    g.labels = {
    	<xsl:for-each select="test">
			<xsl:value-of select="position()-1"/>: 
			<xsl:choose>
				<xsl:when test="throughput &gt; 0">  '<xsl:value-of select="position()"/>'
				</xsl:when>
				<xsl:otherwise> '' </xsl:otherwise>
			</xsl:choose>,
    	</xsl:for-each>
    };
    
    
    <xsl:variable name="max-throughput">
     <xsl:for-each select="test/throughput">
       <xsl:sort data-type="number" order="descending"/>
       <xsl:if test="position()=1"><xsl:value-of select="."/></xsl:if>
     </xsl:for-each>
   </xsl:variable>
    <xsl:variable name="max-response-time">
     <xsl:for-each select="test/response-time">
       <xsl:sort data-type="number" order="descending"/>
       <xsl:if test="position()=1"><xsl:value-of select="."/></xsl:if>
     </xsl:for-each>
   </xsl:variable>
    
    
    g.data("Throughput", [
    	<xsl:for-each select="test">
    		<xsl:if test="throughput &gt; 0">
    		<xsl:value-of select="100*throughput div $max-throughput"/>
    		</xsl:if>
  			<xsl:text>, </xsl:text>
    	</xsl:for-each>
    ]);
    
    g.data("%CPU Utilisation", [
    	<xsl:for-each select="test">
    		<xsl:if test="cpu &gt; 0">
    		<xsl:value-of select="cpu"/>
    		</xsl:if>
    		<xsl:if test="last()">
    			<xsl:text>, </xsl:text>
    		</xsl:if>
    	</xsl:for-each>
    ]);
    
    g.data("Response Time", [
    	<xsl:for-each select="test">
    		<xsl:if test="response-time &gt; 0">
    		<xsl:value-of select="100*response-time div $max-response-time"/>
    		</xsl:if>
    		<xsl:if test="last()">
    			<xsl:text>, </xsl:text>
    		</xsl:if>
    	</xsl:for-each>
    ]);

    g.draw();
  </script>

		
		</div>
	</xsl:template>


</xsl:stylesheet>