package org.netkernel.mod.performance.harness;

import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.urii.ParsedIdentifierImpl;

public class RunSingleTestAccessor extends StandardAccessorImpl
{	
	public RunSingleTestAccessor()
	{	declareThreadSafe(); 
	}	
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{	String identifier=aContext.source("arg:identifier",String.class);
		long period=(Long)aContext.source("arg:period",Long.class);
		String type=aContext.getThisRequest().getArgumentValue(ParsedIdentifierImpl.ARG_ACTIVE_TYPE);
		
		int count=0;
		int n=1;
		long t0=System.currentTimeMillis();
		long te=System.currentTimeMillis()+period;
		while(true)
		{
			for (int i=0; i<n; i++)
			{	INKFRequest req=aContext.createRequest(identifier);
				req.setHeader(INKFRequest.HEADER_FORGET_DEPENDENCIES, Boolean.TRUE);
				Object result=aContext.issueRequest(req);
				count++;
			}
			long t1=System.currentTimeMillis();
			if (t1>te)
			{	t0=t1;
				break;
			}
			else
			{	long duration=(t1-t0)/n;
				if (duration==0) duration=1;
				n=1+(int)((te-t1)/(duration*2));
				t0=t1;
			}
		}
		long actualPeriod=t0-te+period;
		long throughput=((long)count)*60000L/actualPeriod;
		//System.out.println(identifier+" "+count+" "+throughput);
		INKFResponse resp;
		if (type.equals("countTest"))
		{	resp=aContext.createResponseFrom((long)count);
		}
		else if (type.equals("timeTest"))
		{	resp=aContext.createResponseFrom(throughput);
		}
		else throw new Exception("unknown type: "+type);
		resp.setExpiry(INKFResponse.EXPIRY_ALWAYS);
	}
}
