package org.netkernel.mod.performance.nkmark;

import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.layer0.nkf.INKFAsyncRequestListener;
import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.nkf.NKFException;

public class AsyncTestAccessor2 extends StandardAccessorImpl implements INKFAsyncRequestListener
{
	public AsyncTestAccessor2()
	{	declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext aHelper) throws Exception
	{	
		for (int i=9; i>=0; i--)
		{	INKFRequest req = aHelper.createRequest("active:async3");
			req.addArgumentByValue("op", i);
			aHelper.issueAsyncRequest(req).setListener(this);
		}
		aHelper.setNoResponse();
	}

	public void receiveException(NKFException aException, INKFRequest aRequest, INKFRequestContext aContext) throws Exception
	{	throw aException;
	}

	public void receiveResponse(INKFResponseReadOnly aResponse, INKFRequestContext aContext) throws Exception
	{
		int v = (Integer)aResponse.getRepresentation();
		if (v==0)
		{	aContext.createResponseFrom(aResponse);
		}
		else
		{	aContext.setNoResponse();
		}
	}
}
