package org.netkernel.mod.performance.nkmark;

import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFRequestReadOnly;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;

public class CachableDataSet extends StandardAccessorImpl
{
	public CachableDataSet()
	{	declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext aHelper) throws Exception
	{
		INKFRequestReadOnly thisReq=aHelper.getThisRequest();
		String kbString=thisReq.getArgumentValue("Kb");
		String setSize=thisReq.getArgumentValue("setSize");
		Double M=Double.parseDouble(setSize);
		
		int item=(int)(Math.random()*M);
		Class repClass=thisReq.getRepresentationClass();
		INKFResponseReadOnly res=aHelper.sourceForResponse("res:/cache/CachableItem/"+kbString+"/"+Integer.toString(item),repClass);
		INKFResponse resp=aHelper.createResponseFrom(res);
		resp.setExpiry(INKFResponse.EXPIRY_ALWAYS);
	}
}
